/*******************************************************************************
BoundingDiameters
@author Frank Takes - ftakes@liacs.nl
@website http://www.liacs.nl/~ftakes/diameter
**************** consult the README.txt file before using *********************/

class Graph {
	public:	
		// FUNCTIONS
		Graph();
		void print();
		void load(char *, char);
		void save(char *, char);		
		void makeUndir();
		
		// diameter
		int diameter(int, bool);
				
	private:
		// FUNCTIONS
		void setEdge(int, int);
		void setUndirEdge(int, int);
		bool edge(int, int);
		bool exists(int);
		void calcWCC();
		
		// assisting
		void sortEdgeList();			// sort the adjecency lists
		void outputStat(string, int);	// output a certain statistic	
		
		// diameter
		void selectFrom(int &, int);
		int eccentricity(int, int *);
		void preprocess();	
	
		// DATA
		int N;							// largest node number
		int realN;						// number of nodes  
		int M;							// number of directed edges
		bool sorted;					// are the adj. lists sorted?
		bool isUndir;					// is the graph undirected (symmetric)?
		int largestWCC;					// largest component number		
		int numWCC;						// number of components
		
};		// DATA; has to be defined outside class due to C++ memory restrictions
		vector<int> E[MAXN+2];			// adjecency list of each node
		int INDEG[MAXN+2];				// indegree of each node 
		int OUTDEG[MAXN+2];				// outdegree of each node 
		int COUNTINDEG[MAXN+2];			// number of nodes for each indegree 
		int COUNTOUTDEG[MAXN+2];		// number of nodes for each outdegree
		int WCC[MAXN+2];				// wcc number that each node belongs to
		int WCCnodes[MAXN+2];			// number of nodes in each wcc 
		int WCCedges[MAXN+2];			// number of edges in each wcc 
//};
	
		// diameter variables: 											
		int distances[MAXN+2] = {0};	
		bool visited[MAXN] = {0};	
		int previous[MAXN+2] = {0};		
		vector<int> dists[MAXN+2];
		int ecc_upper[MAXN+2];
		int ecc_lower[MAXN+2];
		
		
		
